//css_ref System.Data;
//css_ref System.Transactions;
//css_ref System.Xml;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//css_ref Produmex.Foundation.dll;
//css_ref Produmex.Foundation.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;

using System;
using System.Collections.ObjectModel;
using System.Reflection;
using System.Transactions;
using Produmex.Foundation.Collections;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Diagnostics;
using Produmex.Sbo.Logex.Data.Providers;

namespace PmxCreatingSalesDeliveriesFittinq
{
	class Program
	{
		private static string CONNECTION_STRING = "Server=localhost;CompanyDB=SBODemo_US_314;ExtraDb=PMX_SBODemo_US_314;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2005;DBCultureInfo=en-US;LicenseServer=localhost:30000";

		private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);

		static void Main(string[] args)
		{
			try
			{
				Console.WriteLine(s_log.ToString());
				Console.WriteLine(CONNECTION_STRING);
				CreateSalesDeliveries();
			}
			catch (Exception ex)
			{
				s_log.Error("", ex);
				Console.WriteLine(ex);
				Console.ReadLine();
			}
		}

		private static class Definitions
		{
			public const string ViewName = "PMX_PACKED_PICKLISTS_FOR_CREATING_SALES_DELIVERY_FITTINQ";
			public const string ViewColumn_DocEntry = "PicklistDocEntry";
			public const string ViewColumn_NumOfPackages = "NumOfPackages";

			public const string UDF1 = "U_QuantityLB";
			public const string UDF2 = "U_MIT_PickTable";
			public const string VALUE_FOR_UDF2 = "Background_Table";
		}

		private static void CreateSalesDeliveries()
		{
			//using (PmxDbConnectionSql conn = new PmxDbConnectionSql(CONNECTION_STRING))
			using (SboConnection conn = new SboConnection(CONNECTION_STRING))
			{
				conn.Open();
				Console.Write("Connection is open");

				PmxSalesDeliveryNoteProvider sdnProv = new PmxSalesDeliveryNoteProvider(conn);

				PmxDictionary<string, object> deliveryDataForShipping = new PmxDictionary<string, object>();
				int numberOfPackages = 0;

				deliveryDataForShipping.Add(Definitions.UDF1, numberOfPackages);
				deliveryDataForShipping.Add(Definitions.UDF2, Definitions.VALUE_FOR_UDF2);

				string query = String.Format("SELECT {0},{1} FROM {2}", Definitions.ViewColumn_DocEntry, Definitions.ViewColumn_NumOfPackages, Definitions.ViewName);

				using (ISboRecordset rs = SboRecordsetHelper.RunQuery(s_log, query, conn))
				{
					while (!rs.EoF)
					{
						try
						{
							using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
							{
								conn.EnlistTransaction(Transaction.Current);

								int pickListDocEntry = rs.GetTypedValue<int>(Definitions.ViewColumn_DocEntry);
								numberOfPackages = rs.GetTypedValue<int>(Definitions.ViewColumn_NumOfPackages);

								Collection<int> listOfPackedPickListsForShipping = new Collection<int>();

								listOfPackedPickListsForShipping.Add(pickListDocEntry);
								deliveryDataForShipping[Definitions.UDF1] = numberOfPackages;

								sdnProv.ShipAllItemsForPickList(listOfPackedPickListsForShipping, deliveryDataForShipping, null);

								//Complete transaction
								scope.Complete();
							}
						}
						catch (Exception ex)
						{
							s_log.Error("", ex);
							Console.WriteLine(ex);
						}

						rs.MoveNext();
					}
				}
			}
		}
	}
}
